import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.Color;

/**
 * Title:        The Global Clipboard
 * Description:  my new global clipboard.
 * Copyright:    Copyright (c) 2001
 * Company:      suvi.org
 * @author Suvi
 * @version 0.1
 */

public class InputPanel extends JPanel
{
  protected JTextArea inputData;
  private MessageLocal m_Message;

  public InputPanel(String title)
  {
   setBorder(new TitledBorder(new EtchedBorder(Color.darkGray, Color.black), title) ); //looks nice
   //add(new JLabel("asldkfjaslkfj"));
   inputData = new JTextArea("Enter your text here");
   add(inputData);
   //add(new JScrollPane( new JTextArea("tescht")) ) ;
  }

  //Construtor
  public InputPanel(String title, MessageLocal aMessage)
  {
   this.m_Message = aMessage;
   m_Message.setSenderName(title);
   setBorder(new TitledBorder(new EtchedBorder(Color.darkGray, Color.black), title) ); //looks nice

   //add(new JLabel("asldkfjaslkfj"));
   inputData = new JTextArea("Enter your text here");
   m_Message.setTextMessage(inputData.getText());
   add(inputData );
   //add(new JScrollPane( new JTextArea("tescht")) ) ;
   inputData.getDocument().addDocumentListener(new DocumentListener()
   {
     public void insertUpdate(DocumentEvent e)
     {
      //System.out.println("insertUpdate");
      m_Message.setTextMessage(inputData.getText());
     }

     public void removeUpdate(DocumentEvent e)
     {
      //System.out.println("removeUpdate");
      m_Message.setTextMessage(inputData.getText());
     }

     public void changedUpdate(DocumentEvent e)
     {
      //System.out.println("changeUpdate");
      m_Message.setTextMessage(inputData.getText());
     }
   });
  }
}
