import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

/**
 * Title:        The Global Clipboard
 * Description:  my new global clipboard.
 * Copyright:    Copyright (c) 2001
 * Company:      suvi.org
 * @author Suvi
 * @version 0.1
 */

public class MainFrame extends JFrame
{
  private JPanel contentPane;
  private JMenuBar m_jMenuBar = new JMenuBar();
  private JMenu jMenuFile = new JMenu();
  private JMenuItem jMenuFileExit = new JMenuItem();
  private JMenu jMenuCommand = new JMenu();
  private JMenuItem jMenuCommandLocalScan = new JMenuItem();
  private JMenuItem jMenuCommandTargetScan = new JMenuItem();
  private JMenu jMenuHelp = new JMenu();
  private JMenuItem jMenuHelpAbout = new JMenuItem();
  private JLabel m_statusBar = new JLabel();
  private BorderLayout m_borderLayout = new BorderLayout();

  private SimplePanel m_simplePanel;
  private SimpleContainer m_simpleContainer;

  private Controll myControll;
  private MessageLocal m_Message;
  private Vector m_RemoteMessageVector;

  /**Construct the frame*/
  public MainFrame(MessageLocal localMessage, Controll aControll)
  {
    this.m_Message = localMessage;
    this.myControll = aControll;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      guiInit();
    }
    catch(Exception e)
     { e.printStackTrace(); }
  }
  /**Component initialization*/
  private void guiInit() throws Exception
  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(MainFrame.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(m_borderLayout);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Suvi's global clipboard");
    //---------MenuFile
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { jMenuFileExit_actionPerformed(e); }
    });
    jMenuFile.add(jMenuFileExit);
    //---------MenuCommand
    jMenuCommand.setText("Command");
    jMenuCommandLocalScan.setText("scan local subnet");
    jMenuCommandLocalScan.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { jMenuCommandLocalScan_actionPerformed(e); }
    });
    jMenuCommand.add(jMenuCommandLocalScan);
    jMenuCommandTargetScan.setText("scan target...");
     jMenuCommandTargetScan.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { jMenuCommandTargetScan_actionPerformed(e); }
    });
    jMenuCommand.add(jMenuCommandTargetScan);
    //---------MenuHelp
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { jMenuHelpAbout_actionPerformed(e); }
    });
    jMenuHelp.add(jMenuHelpAbout);
    m_jMenuBar.add(jMenuFile);
    m_jMenuBar.add(jMenuCommand);
    m_jMenuBar.add(jMenuHelp);
    this.setJMenuBar(m_jMenuBar);

    String alphaMessage = " this is the\n pre-pre-alpha\n version of the\n suvi's globalclipboard ";
    m_simpleContainer = new SimpleContainer();
    m_simplePanel = new SimplePanel("suvi.org",alphaMessage,m_simpleContainer);

    //m_MessageImpl = new MessageImpl("remote");
    //new SimplePanel(m_RemoteMessage, m_simpleContainer);

    m_simpleContainer.add(new InputPanel(m_Message.getSenderNameLocal(),m_Message));

    //the new stuff
    //contentPane.add(m_simplePanel);
    contentPane.add(m_simpleContainer);

    m_statusBar.setText("initializing done");
    contentPane.add(m_statusBar, BorderLayout.SOUTH);
  }
  /**File | Exit action performed*/
  public void jMenuFileExit_actionPerformed(ActionEvent e)
  {
    System.out.println("---This was it, goodbye---");
    System.exit(0);
  }
  /**Command |Scan local subnet*/
  public void jMenuCommandLocalScan_actionPerformed(ActionEvent e)
  {
    System.out.println("---Scanning IP-Range x.x.x.0 to x.x.x.256---");
    myControll.scanSubnet(); //scanning local subnet
  }
  /**Command |Scan target host*/
  public void jMenuCommandTargetScan_actionPerformed(ActionEvent e)
  {
    System.out.println("---Scanning specified target---");
    String result = JOptionPane.showInputDialog(this,"enter an IPAdress or a host name","What's the target?",JOptionPane.QUESTION_MESSAGE);
    System.out.println(result);
    if (result!=null)
    {
     myControll.scanTarget(result);
    }
  }
  /**Help | About action performed*/
  public void jMenuHelpAbout_actionPerformed(ActionEvent e)
  {
    MainFrame_AboutBox dlg = new MainFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      jMenuFileExit_actionPerformed(null);
    }
  }
  //add a Message
  public void addMessage(Message aMessage)
  {
   try
   {
    new SimplePanel(aMessage, m_simpleContainer);
    System.out.println("new partner: " + aMessage.GetSenderName());  //shell
    m_statusBar.setText("new partner: " + aMessage.GetSenderName()); //statusbar
    this.invalidate();
   }
   catch(Exception e)
   { System.out.println(e); }
  }
  //remove a Message
  public void removeMessage(Message aMessage)
  {
   // to do
  }
}
