import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.rmi.*;
import java.rmi.server.*;

/**
 * Title:        The Global Clipboard
 * Description:  my new global clipboard.
 * Copyright:    Copyright (c) 2001
 * Company:      suvi.org
 * @author Suvi
 * @version 1.0
 */

public class SimplePanel extends UnicastRemoteObject implements MessageObserver
{
  private JPanel myJPanel;
  private JTextArea textMessage;
  private Message myMessage;
  private TitledBorder myTitledBorder;
  private Container m_Container;
  private int counter=1;
  private String m_title;

  public SimplePanel(String title, String text,Container aContainer) throws RemoteException
  {
    m_Container = aContainer;
    myJPanel = new JPanel();
    m_Container.add(myJPanel);
    this.m_title = title;

    //this.setBorder(new LineBorder(Color.blue) );
    //this.setBorder(new EtchedBorder() );
    myTitledBorder = new TitledBorder(title);
    myJPanel.setBorder(myTitledBorder);
    textMessage = new JTextArea(text);
    textMessage.setEditable(false);
    //textMessage.setEnabled(false);
    myJPanel.add(textMessage,BorderLayout.CENTER);
    //myJPanel.setMinimumSize(new Dimension(200,100));
  }

  public SimplePanel(Message aMessage,Container aContainer) throws RemoteException
  {
    m_Container = aContainer;
    myJPanel = new JPanel();
    m_Container.add(myJPanel);

    this.myMessage = aMessage;
    myMessage.addMessageObserver(this);

    myTitledBorder = new TitledBorder(myMessage.GetSenderName());
    myJPanel.setBorder(myTitledBorder);

    textMessage = new JTextArea(myMessage.GetTextMessage());
    textMessage.setEditable(false);
    myJPanel.add(textMessage);
  }

  public void update() throws RemoteException
  {
    System.out.println(m_title+ " update " + counter);
    counter++;
    try
    {
     textMessage.setText(myMessage.GetTextMessage());
     myTitledBorder.setTitle(myMessage.GetSenderName());
    }
    catch (RemoteException re)
    {
      System.out.println(re);
      textMessage.setText("RemoteException - try again"); //I have to remove this here actually
      //myTitledBorder.setTitle("RemoteException");
    }
    //myJPanel.invalidate();
  }

}
