import java.rmi.*;
import java.rmi.server.*;
import javax.swing.*;
import java.net.*;
import java.util.*;

/**
 * Title:        The Global Clipboard
 * Description:  my new global clipboard.
 * Copyright:    Copyright (c) 2001
 * Company:      suvi.org
 * @author Suvi
 * @version 0.1
 */

/** Implements the GCB interface*/
public class GCBImpl extends UnicastRemoteObject implements GCB
{
  private MessageImpl myMessageImpl;
  private Vector myRemoteMessages;
  private GCBDesktop m_GCBDesktop;

  public GCBImpl() throws RemoteException
  {
   myRemoteMessages = new Vector();
   String inputValue = null;
   /*while(inputValue == null)
   {
    inputValue = JOptionPane.showInputDialog("Enter your name");
   }*/
   try
   {
     inputValue = InetAddress.getLocalHost().toString();
   }
   catch(Exception e)
   { inputValue = "unknown host"; }
   myMessageImpl = new MessageImpl(inputValue);
  }

  /** returns myMessage | RMI */
  public Message getMessage() throws RemoteException
  {
   return (myMessageImpl);
  }

  /** set a GCBDesktop for presentation*/
  public void setMainDesktop(GCBDesktop aGCBDesktop)
  {
   //Tue due the fact, that this class allready extends a UnicastRemoteObject
   //it's not possible to set it in the constructor
   this.m_GCBDesktop = aGCBDesktop;
  }

  /** returns myMessage */
 public MessageImpl getMessageImpl()
 {
    return (myMessageImpl);
 }

  /** adds a Messages to the message list and to the GCBDesktop*/
  public void addRemoteMessage(Message aMessage) throws RemoteException
  {
   myRemoteMessages.add(aMessage);
   if (m_GCBDesktop != null)
   {
    m_GCBDesktop.addMessage(aMessage);
   }
  }
  
  /** removes a Message from the message list*/
  public void removeRemoteMessage(Message aMessage) throws RemoteException
  {
   myRemoteMessages.remove(aMessage);
  }

}