/*
 * GCBInputInternalFrame.java
 * @author  suvi
 * Created on June 17, 2004, 11:20 AM
 */

import javax.swing.*;
import javax.swing.event.*;

/**
 * a JInternalFrame displaying a field for text input
 */
public class GCBInputInternalFrame extends JInternalFrame
{
  protected JTextArea inputData;
  private MessageLocal m_Message;
  private boolean autoCopyClipboard = false;
  static int openFrameCount = 1;
  static final int xOffset = 430, yOffset = 30;
    
    /** Creates a new instance of GCBInputInternalFrame */
    public GCBInputInternalFrame(String title, MessageLocal aMessage)
    {
     super(title, 
          true, //resizable
          false, //closable //TO DO make closabe ver.0.3
          true, //maximizable
          true);//iconifiable
     
     System.out.println("Constructing GCBInputInternalFrame");
     
     this.m_Message = aMessage;
     m_Message.setSenderName(title);
     inputData = new JTextArea("Enter your text here");
     this.getContentPane().add(inputData);    
     
     /** Documentlistener for updates */
     inputData.getDocument().addDocumentListener(new DocumentListener()
     {
      public void insertUpdate(DocumentEvent e)
      {
       //System.out.println("insertUpdate");
       m_Message.setTextMessage(inputData.getText());
      }
      public void removeUpdate(DocumentEvent e)
      {
       //System.out.println("removeUpdate");
       m_Message.setTextMessage(inputData.getText());
      }
      public void changedUpdate(DocumentEvent e)
      {
       //System.out.println("changeUpdate");
       m_Message.setTextMessage(inputData.getText());
      }
     });
     this.setSize(300,300);  
    //Set the window's location.
     this.setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
     this.setVisible(true);
    }
   
   /** is autmatic copy of system clipboard to gcb on? */
   public boolean getAutoCopyClipboard()
   {
     return this.autoCopyClipboard;
   }
   
   /** set automatic copy of system clipboard to gcb on or off */
   public void setAutoCopyClipboard(boolean oNoFF)
   {
     this.autoCopyClipboard = oNoFF;
     //To Do ... do automatic
   }
    
}
