/*
 * GCBInternalFrame.java
 * @author  suvi
 * Created on June 14, 2004, 9:53 AM
 */
import javax.swing.JInternalFrame;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.rmi.*;
import java.rmi.server.*;

/**
 * GCBInternalFrame is a JInternalFrame  displaying a remote Message
 */
public class GCBInternalFrame extends UnicastRemoteObject implements MessageObserver
{
    static int openFrameCount = 0;
    static final int xOffset = 30, yOffset = 30;
    private int counter=1;
    private String m_title;
    private Container m_Container;
    private Message myMessage;
    private JPanel myJPanel;
    private JInternalFrame m_JInternalFrame;
    private JTextArea textMessage;

    /** Creates a new instance of GCBInternalFrame  with a String*/
    public GCBInternalFrame(String title, String text,Container aContainer) throws RemoteException
    {
      m_Container = aContainer;
      m_title = title;
      textMessage = new JTextArea(text);
      textMessage.setEditable(false);
      myJPanel = new JPanel();
      myJPanel.add(textMessage,BorderLayout.CENTER);
      m_JInternalFrame = new JInternalFrame(m_title+" #"+(++openFrameCount),false,false,false,true);//resizable,closable,maximizable,iconifiable
      m_JInternalFrame.getContentPane().add(myJPanel);
      //...Then set the window size or call pack...
      m_JInternalFrame.setSize(300,200);
      //Set the window's location.
      m_JInternalFrame.setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
      aContainer.add(m_JInternalFrame);
      m_JInternalFrame.setVisible(true); 
    }
    
    /** Creates a new instance of GCBInternalFrame with a remote Message*/
    public GCBInternalFrame(Message aMessage,Container aContainer) throws RemoteException
    {
      m_Container = aContainer;
      System.out.println("Creating GCBInternalFrame with Message!");

      this.myMessage = aMessage;
      myMessage.addMessageObserver(this);
      textMessage = new JTextArea(myMessage.GetTextMessage());
      textMessage.setEditable(false);
      myJPanel = new JPanel();
      myJPanel.add(textMessage,BorderLayout.CENTER);
      m_title = new String(myMessage.GetSenderName());
      m_JInternalFrame = new JInternalFrame(m_title+" #"+(++openFrameCount),true,false,true,true);//resizable,closable,maximizable,iconifiable
      m_JInternalFrame.getContentPane().add(myJPanel);
      //...Then set the window size or call pack...
      m_JInternalFrame.setSize(300,200);
      //Set the window's location.
      m_JInternalFrame.setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
      aContainer.add(m_JInternalFrame);
      m_JInternalFrame.setVisible(true);
    }
  
  /** if there is an update on the message we fetch and display it */
  public void update() throws RemoteException
  {
    System.out.println(m_title+ " update " + counter);
    counter++;
    try
    {//fetching message and display it 
     textMessage.setText(myMessage.GetTextMessage());
    }
    catch (RemoteException re)
    {
      System.out.println(re);
      textMessage.setText("RemoteException - try again"); //To do: I have to remove this here actually
    }
  }
    
}
