import javax.swing.UIManager;
import java.awt.*;
import java.rmi.registry.*;
import java.rmi.*;
import java.util.*;
import java.net.*;

/**
 * Title:        The Global Clipboard
 * Description:  my new global clipboard.
 * Copyright:    Copyright (c) 2001-2004
 * Company:      suvi.org
 * @author Suvi
 * @version 0.3
 */

public class GCBMain
{
  boolean packFrame = false;
  private MessageImpl myMessageImpl;
  private GCBImpl myGCBImpl;
  private GCB myRemoteGCB;
  private Vector remoteGCBVector;
  private Message myRemoteMessage;
  private Registry localRegistry;
  private Registry remoteRegistry;
  private boolean firstgcb;
  private Controll myControll;

  /**Construct the application*/
  public GCBMain()
  {
    System.out.println("we're starting up");
    
    //Make sure we have nice window decorations.
    javax.swing.JFrame.setDefaultLookAndFeelDecorated(true);
   
    remoteGCBVector = new Vector();
    try
    { //shows all local address, but doesen't work
     InetAddress testAdr[] = InetAddress.getAllByName("127.0.0.1");
     for(int z=0; z < testAdr.length; z++)
     {
      System.out.println(testAdr[z].toString());
     }

     myGCBImpl = new GCBImpl(); //creating a gcb
     myMessageImpl = myGCBImpl.getMessageImpl(); //creating a message
     try
     { //create local registry
      localRegistry = LocateRegistry.createRegistry(3377);
      System.out.println("registry created");
      this.firstgcb = true;
      System.out.println(localRegistry);
     }
     catch( RemoteException re)
     {//Registry already exists
      localRegistry = LocateRegistry.getRegistry(3377);
      System.out.println("registry already exists");
      this.firstgcb = false;
      System.out.println(localRegistry);
     }

     try
     { //binding gcb at registry
      localRegistry.bind("gcb", myGCBImpl);
      myRemoteMessage = myMessageImpl;
     }
     catch(AlreadyBoundException abe)
     { //gcb allready bound
      myRemoteGCB= (GCB) localRegistry.lookup("gcb");
      myRemoteMessage = myRemoteGCB.getMessage();
     }
    myControll = new Controll(myGCBImpl, myMessageImpl);
    
    //setting up GCBDesktop
    GCBDesktop gcbDesktop = new GCBDesktop(myMessageImpl, myControll); 
    myGCBImpl.setMainDesktop(gcbDesktop); 
     //this is for testing on only, if you got just one computer
     if (!this.firstgcb) myControll.scanTarget("127.0.0.1");
     //Scanning local subnet
     //myControll.scanSubnet();
    }
    catch (Exception e)
    { e.printStackTrace();
      System.exit(1);
    }

     
   }
  /**Main method*/
  public static void main(String[] args)
  {
    /*try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
     { e.printStackTrace(); }*/
       
    new GCBMain();
  }
}
