import java.rmi.*;
import java.rmi.server.*;
import java.util.*;

/**
 * Title:        The Global Clipboard
 * Description:  my new global clipboard.
 * Copyright:    Copyright (c) 2001
 * Company:      suvi.org
 * @author Suvi
 * @version 0.1
 */

/** a LocalMessage makes as Message localy aviable */
public class LocalMessage extends UnicastRemoteObject implements MessageObserver
{
  private Message m_Message;
  private Vector vectorObserver;
  private Observable dummy;

  /** Constructs a LocalMessage */
  public LocalMessage(Message aMessage) throws RemoteException
  {
   m_Message = aMessage;
   vectorObserver = new Vector();
   dummy = new Observable();
  }

  /** returns the sendername */
  public String GetSenderName()
  {
    String SenderName;
    try
    {
      SenderName =  m_Message.GetSenderName();
    }
    catch (RemoteException re)
    {
      System.out.println(re);
      SenderName = "RemoteException";
    }
    return (SenderName);

  }

  /** returns the textmessage */
  public String GetTextMessage()
  {
    String TextMessage;
    try
    {
      TextMessage =  m_Message.GetTextMessage();
    }
    catch (RemoteException re)
    {
      System.out.println(re);
      TextMessage = "RemoteException";
    }
    return (TextMessage);
  }

  /**informing all observers*/
  public void update() throws RemoteException
  {
    for(int i=0; i < vectorObserver.size(); i++)
    {
      ((Observer) vectorObserver.get(i)).update(dummy,dummy);
    }
  }

  /** Ad Overserv to this LocalMEssage*/
  public void addObserver(Observer o)
  {
   vectorObserver.add(o);
  }

}