import java.rmi.*;
import java.rmi.server.*;
import java.util.*;

/**
 * Title:        The Global Clipboard
 * Description:  my new global clipboard.
 * Copyright:    Copyright (c) 2001-2004
 * Company:      suvi.org
 * @author Suvi
 * @version 0.1
 */

/**Implementation of a remote Message */
public class MessageImpl extends UnicastRemoteObject implements Message, MessageLocal
{
  private String senderName;
  private String textMessage = "no message set";
  private Vector myVectorObserver;

  /**Constructs a Message */
  public MessageImpl(String senderName) throws RemoteException
  {
    this.senderName = senderName;
    myVectorObserver = new Vector();
  }

  /**adds a MessageObserver to the vector list */
  public void addMessageObserver(MessageObserver mo) throws RemoteException
  {
   myVectorObserver.add(mo);
  }
  
  /**deletes a MessageObserver to the vector list */
  public void deleteMessageObserver(MessageObserver mo) throws RemoteException
  {
   myVectorObserver.remove(mo);
  }

  /**sets the text of the message */
  public void setTextMessage(String textMessage)
  {
   this.textMessage = textMessage;
   notifyObservers();
  }

  /**returns the sender name */
  public String getSenderNameLocal()
  {
   return (senderName);
  }

  /** sets the senderName */
  public void setSenderName(String senderName)
  {
   this.senderName = senderName;
   notifyObservers();
  }

  /**notify the Observes for updates */
  private void notifyObservers()
  {
   for(int i=0; i < myVectorObserver.size(); i++)
   {
    try
    {
     ((MessageObserver)myVectorObserver.get(i)).update();
    }
    catch(RemoteException re)
    {
     System.out.println(re);
    }
   }
  }

  /** returns the sender Name */
  public String GetSenderName() throws RemoteException
  {
   return(senderName);
  }

  /**returns the text message */
  public String GetTextMessage() throws RemoteException
  {
   return(textMessage);
  }


}