import java.rmi.registry.*;
import java.rmi.*;
import java.net.*;

/**
 * Title:        The Global Clipboard
 * Description:  my new global clipboard.
 * Copyright:    Copyright (c) 2001
 * Company:      suvi.org
 * @author Suvi
 * @version 0.1
 */

/**Thread for scanning a spoecific IP-Address for a GCB */
public class ScanThread extends Thread
{
  private GCBImpl m_GCBImpl;
  private GCB myRemoteGCB;
  private String m_IPAdress;
  private Registry remoteRegistry;
  private Message myRemoteMessage;
  private Message m_LocalMessage;

  /**Constructs the thread */
  public ScanThread(GCBImpl aGCBImpl, Message aLocalMessage, String aIPAdress)
  {
   this.m_IPAdress = aIPAdress;
   this.m_GCBImpl = aGCBImpl;
   this.m_LocalMessage = aLocalMessage;
   this.setDaemon(true); //i am just a deamon thread working for others
   this.start(); //we got a new thread running
  }

  /**task of the thread */
  public void run()
  {
    try
    {
       System.out.print("Trying: " + m_IPAdress + " ");
       if (m_IPAdress.endsWith("0") || m_IPAdress.endsWith("5") ) { System.out.println(""); }
       //remoteRegistry = LocateRegistry.getRegistry(hostaddress + Integer.toString(i),3377);
       remoteRegistry = LocateRegistry.getRegistry(m_IPAdress,3377);
       //System.out.println(remoteRegistry);
       myRemoteGCB= (GCB) remoteRegistry.lookup("gcb"); //found a clipboard
       System.out.println("JUHU found a gcb on: " + m_IPAdress);
       myRemoteMessage = myRemoteGCB.getMessage(); //getting message
       m_GCBImpl.addRemoteMessage(myRemoteMessage); //adding to local clipboard
       myRemoteGCB.addRemoteMessage(this.m_LocalMessage); //adding my Message to the remote clipboard
    }
    catch(RemoteException re)
    {
      System.out.println("No gcb on: " + m_IPAdress);
     //System.out.println(re);
    }
    catch (Exception e)
    {
     System.out.println(e);
    }
  }

}